package dev.flyfish.framework.approval.domain.record;

import dev.flyfish.framework.annotations.Entity;
import dev.flyfish.framework.annotations.Property;
import dev.flyfish.framework.approval.enums.ApproveAction;
import dev.flyfish.framework.domain.base.AuditDomain;
import lombok.Getter;
import lombok.Setter;

/**
 * 审批记录
 *
 * @author wangyu
 */
@Entity(table = "t_approve_records", collection = "approve-records")
@Getter
@Setter
public class ApproveRecord extends AuditDomain {

    // 是否已审批
    private Boolean approved;

    // 模块
    private String module;

    // 模块名称
    @Property(column = "module_name")
    private String moduleName;

    // 数据id
    @Property(column = "data_id")
    private String dataId;

    // 审批人
    private String approver;

    // 审批动作
    private ApproveAction action;

    // 审批意见
    private String opinion;
}
