package dev.flyfish.framework.validation.spi;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

import static java.lang.annotation.ElementType.TYPE;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

/**
 * 指定动态分组
 *
 * @author wangyu
 */
@Target({TYPE})
@Retention(RUNTIME)
@Documented
public @interface ConditionalGroup {

    /**
     * 自定义验证分组提供者
     *
     * @return 结果
     */
    Class<? extends ConditionalValidGroupProvider<?>>[] value() default {};

    /**
     * 是否不验证编码
     *
     * @return 结果
     */
    boolean codeless() default false;

    /**
     * 是否不验证名称
     *
     * @return 结果
     */
    boolean nameless() default false;
}
