# 核心数据框架

本模块是flyfish framework的最核心能力
其提供无感知的多种数据源支持，并完整适配了mongodb和rdbms的查询表现，
用户只需要用一套api即可完成数据的查询或修改，无需为了底层实现而大费周章重新开发。

## 核心架构
1. 基于Spring SPI模式，声明式注入查询实现工厂，动态替换查询构建逻辑
2. 按需引入，不浪费任何依赖，节省空间。使用maven的按需引入模式，让打包后的结果不必因为重量级的框架而变得冗余
3. 指哪打哪，稳定快速。集成最新版本的spring mongo引擎和spring data r2dbc
4. 核心框架广泛使用，保证"0bug"。

## 无限扩展
1. 根据实际业务需求，采用mongo、jpa、r2dbc的方式，动态选择实现，而业务和底层存储实现无关，完全解耦
2. 健壮的架构，能够支撑99%的业务
3. 完善的关联机制，多表关联做到全自动化
