package dev.flyfish.framework.annotations;

import dev.flyfish.framework.config.DecryptConfig;
import org.springframework.context.annotation.Import;

import java.lang.annotation.*;

/**
 * 启用加解密属性
 * @author wangyu
 */
@Target({ElementType.TYPE})
@Retention(RetentionPolicy.RUNTIME)
@Documented
@Import(DecryptConfig.class)
public @interface EnablePropertyEncrypt {

    /**
     * 默认密码
     *
     * @return 结果
     */
    String defaultPassword() default "flyfish-framework";
}
