package dev.flyfish.framework.query;

import dev.flyfish.framework.domain.base.Domain;
import dev.flyfish.framework.query.spi.QueryFactory;
import org.springframework.core.io.support.SpringFactoriesLoader;
import org.springframework.data.repository.core.EntityInformation;

import java.util.List;
import java.util.Optional;

/**
 * 查询工厂持有者
 *
 * @author wangyu
 */
class QueryFactories {

    @SuppressWarnings("rawtypes")
    private static final List<QueryFactory> FACTORIES =
            SpringFactoriesLoader.loadFactories(QueryFactory.class, null);

    /**
     * 获取目标查询工厂
     *
     * @param entityInformation 实体信息
     * @return 结果
     */
    @SuppressWarnings({"unchecked", "rawtypes"})
    public static Optional<QueryFactory> getFactory(EntityInformation<? extends Domain, String> entityInformation) {
        return FACTORIES.stream().filter(factory -> factory.supports(entityInformation))
                .findFirst();
    }
}
