package dev.flyfish.framework.domain.authorized;

import dev.flyfish.framework.annotations.Property;
import dev.flyfish.framework.domain.base.AuditDomain;
import lombok.Getter;
import lombok.Setter;

/**
 * 带鉴权的实体，主要以部门隔绝
 */
@Setter
@Getter
public abstract class AuthorizedDomain extends AuditDomain {

    // 作用域id，一般是部门。用户存储时插入
    @Property(readonly = true)
    private String authorizeId;

    // 是否已发布，已发布的内容，谁都不能修改
    @Property(readonly = true)
    private Boolean published = false;
}
