package dev.flyfish.framework.logging.domain;

import dev.flyfish.framework.domain.base.Domain;
import dev.flyfish.framework.domain.po.Department;
import dev.flyfish.framework.domain.po.Permission;
import dev.flyfish.framework.domain.po.Role;
import dev.flyfish.framework.domain.po.User;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.Arrays;

/**
 * 缺省的实体描述
 * @author wangyu
 */
@AllArgsConstructor
@Getter
public enum DomainDescriptions {

    DEFAULT(null, "未知数据"),
    ADMIN_USER(User.class, "系统用户"),
    ROLE(Role.class, "用户角色"),
    PERMISSION(Permission.class, "用户权限"),
    LOG(Log.class, "系统日志"),
    DEPARTMENT(Department.class, "部门");

    private final Class<? extends Domain> domainClass;

    private final String name;

    public static DomainDescriptions getByClass(Class<? extends Domain> clazz) {
        return Arrays.stream(values()).filter(descriptions -> descriptions.domainClass == clazz)
                .findFirst().orElse(DEFAULT);
    }
}
