package dev.flyfish.framework.user.config.audit;

import dev.flyfish.framework.context.UserContext;
import dev.flyfish.framework.domain.base.Domain;
import lombok.RequiredArgsConstructor;
import org.springframework.data.domain.AuditorAware;
import org.springframework.stereotype.Component;

import java.util.Optional;

/**
 * 用户上下文审查工具
 *
 * @author wangyu
 */
@Component
@RequiredArgsConstructor
public class UserAuditor implements AuditorAware<String> {

    private final UserContext userContext;

    /**
     * 在异步上下文中获取结果
     *
     * @return 结果
     */
    @Override
    public Optional<String> getCurrentAuditor() {
        return Optional.ofNullable(userContext.currentUser())
                .map(Domain::getName);
    }

}
