package dev.flyfish.framework.user.domain;


import dev.flyfish.framework.domain.po.Permission;
import dev.flyfish.framework.domain.tree.TreeQo;
import dev.flyfish.framework.query.QueryDefinition;
import lombok.Getter;
import lombok.Setter;
import org.springframework.data.domain.Sort;

/**
 * 权限查询实体
 *
 * @author wybab
 */
@Getter
@Setter
public class PermissionQo extends TreeQo<Permission> {

    private Boolean admin;

    private String type;

    @Override
    public Sort sorts() {
        return Sort.by(Sort.Order.asc("_id"));
    }

    @Override
    public QueryDefinition queryBuilder() {
        return super.queryBuilder().mutate()
                .and(Permission::isAdmin).eq(admin)
                .and(Permission::getType).eq(type);
    }
}
